# JSXGraph Reference

## JavaScript must be enabled in order for you to use JSXGraph and JSXGraph reference. However, it seems JavaScript is either disabled or not supported by your browser.

Class Index | File Index

## Elements

## Classes

- _global_
- Angle
- Arc
- Arrow
- Arrowparallel
- Axis
- Bisector
- Bisectorlines
- Button
- Cardinalspline
- Checkbox
- Circle
- Circumcenter
- Circumcircle
- CircumcircleArc
- CircumcircleSector
- Conic
- Curve
- Derivative
- Ellipse
- Functiongraph
- Glider
- Grid
- Group
- Hatch
- Hyperbola
- Image
- Incenter
- Incircle
- Inequality
- Input
- Integral
- Intersection
- JXG
- JXG.AbstractRenderer
- JXG.Board
- JXG.C
- JXG.CA
- JXG.CanvasRenderer
- JXG.Circle
- JXG.Complex
- JXG.Composition
- JXG.Coords
- JXG.CoordsElement
- JXG.Curve
- JXG.Dump
- JXG.EventEmitter
- JXG.GeometryElement
- JXG.GeonextParser
- JXG.Group
- JXG.Image
- JXG.JessieCode
- JXG.JSXGraph
- JXG.Line
- JXG.Math
- JXG.Math.Geometry
- JXG.Math.Numerics
- JXG.Math.Poly
- JXG.Math.Poly.Monomial
- JXG.Math.Poly.Polynomial
- JXG.Math.Poly.Ring
- JXG.Math.Statistics
- JXG.Math.Symbolic
- JXG.NoRenderer
- JXG.Options
- JXG.Point
- JXG.Polygon
- JXG.Server
- JXG.Server.modules
- JXG.SVGRenderer
- JXG.Text
- JXG.Ticks
- JXG.Transformation
- JXG.Turtle
- JXG.Util
- JXG.Util.Base64
- JXG.Util.Unzip
- JXG.Util.UTF8
- JXG.VMLRenderer
- JXG.XML
- Label
- Line
- Locus
- MajorArc
- MajorSector
- Midpoint
- MinorArc
- MinorSector
- Mirrorelement
- Mirrorpoint
- NonReflexAngle
- Normal
- Orthogonalprojection
- OtherIntersection
- Parabola
- Parallel
- Parallelpoint
- Perpendicular
- PerpendicularPoint
- PerpendicularSegment
- Point
- PolarLine
- PolePoint
- Polygon
- Quadtree
- RadicalAxis
- Reflection
- ReflexAngle
- RegularPolygon
- Riemannsum
- Sector
- Segment
- Semicircle
- Slider
- Slopetriangle
- Spline
- Stepfunction
- Tangent
- Tapemeasure
- Text
- Ticks
- Tracecurve
- Transformation
- Turtle

# Class JXG.Line

JXG.GeometryElement
↳ JXG.Line

Creates a new basic line object. Do not use this constructor to create a line. Use JXG.Board#create with type Line, Arrow, or Axis instead.
Defined in: line.js.
Extends JXG.GeometryElement.

Class Summary
Constructor Attributes | Constructor Name and Description
--- | ---
| JXG.Line(board, p1, p2, id, name, withLabel, layer) The Line class is a basic class for all kind of line objects, e.g.

Fields borrowed from class JXG.GeometryElement:
  _org_type, _pos, ancestors, baseElement, board, childElements, dash, descendants, draft, dump, elementClass, elType, fillColor, fillOpacity, fixed, frozen, hasLabel, highlight, highlighted, highlightFillColor, highlightFillOpacity, highlightStrokeColor, highlightStrokeOpacity, highlightStrokeWidth, id, inherits, isDraggable, isReal, lastDragTime, methodMap, mouseover, name, needsRegularUpdate, needsUpdate, notExistingParents, numTraces, parents, quadraticform, rendNode, scalable, shadow, snapToGrid, stdform, strokeColor, strokeOpacity, strokeWidth, subs, symbolic, trace, traceAttributes, traces, transformations, transitionDuration, type, visible, visProp, visPropCalc, withLabel

Field Summary
Field Attributes | Field Name and Description
--- | ---
| defaultTicks Reference of the ticks created automatically when constructing an axis.
<private> | parentPolygon If the line is the border of a polygon, the polygon object is stored, otherwise null.
| point1 Startpoint of the line.
| point2 Endpoint of the line.
| ticks Array of ticks storing all the ticks on this line.

Fields borrowed from class JXG.GeometryElement:
  _org_type, _pos, ancestors, baseElement, board, childElements, dash, descendants, draft, dump, elementClass, elType, fillColor, fillOpacity, fixed, frozen, hasLabel, highlight, highlighted, highlightFillColor, highlightFillOpacity, highlightStrokeColor, highlightStrokeOpacity, highlightStrokeWidth, id, inherits, isDraggable, isReal, lastDragTime, methodMap, mouseover, name, needsRegularUpdate, needsUpdate, notExistingParents, numTraces, parents, quadraticform, rendNode, scalable, shadow, snapToGrid, stdform, strokeColor, strokeOpacity, strokeWidth, subs, symbolic, trace, traceAttributes, traces, transformations, transitionDuration, type, visible, visProp, visPropCalc, withLabel

Method Summary
Method Attributes | Method Name and Description
--- | ---
| addTicks(ticks) Adds ticks to this line.
| addTransform(transform) Add transformations to this line.
<private> | generatePolynomial(p) Used to generate a polynomial for a point p that lies on this line, i.e.
| getAngle() Determines the angle between the positive x axis and the line.
| getRise() Calculates the y intersect of the line.
| getSlope() Calculates the slope of the line.
| hasPoint(x, y) Checks whether (x,y) is near the line.
| L() The distance between the two points defining the line.
<private> | maxX() Treat the element as parametric curve
<private> | minX() Treat the element as a parametric curve
| removeAllTicks() Removes all ticks from a line.
| removeTicks(tick) Removes ticks identified by parameter named tick from this line.
<private> | setLabelRelativeCoords(relCoords) Adjusts Label coords relative to Anchor.
<private> | setStraight(straightFirst, straightLast) Determines whether the line is drawn beyond JXG.Line#point1 and JXG.Line#point2 and updates the line.
<private> | updateRenderer() Uses the boards renderer to update the line.
<private> | updateSegmentFixedLength() Update segments with fixed length and at least one movable point.
<private> | updateStdform() Updates the stdform derived from the parent point positions.
| X(t) Treat the line as parametric curve in homogeneous coordinates, where the parameter t runs from 0 to 1.
| Y(t) Treat the line as parametric curve in homogeneous coordinates.
| Z(t) Treat the line as parametric curve in homogeneous coordinates.

Methods borrowed from class JXG.GeometryElement:
  _set, addChild, addDescendants, addParents, addRotation, animate, bounds, clearTrace, cloneToBackground, countChildren, createGradient, createLabel, draggable, fullUpdate, getAttribute, getAttributes, getLabelAnchor, getName, getParents, getProperty, getTextAnchor, getType, handleSnapToGrid, hideElement, labelColor, noHighlight, normalize, prepareUpdate, remove, removeChild, removeDescendants, resolveShortcuts, setArrow, setAttribute, setDash, setDisplayRendNode, setLabel, setLabelText, setName, setParents, setPosition, setPositionDirectly, setProperty, showElement, snapToPoints, update, updateVisibility

Events borrowed from class JXG.GeometryElement:
  attribute, attribute:<attribute><attribute>, down, drag, mousedown, mousedrag, mousemove, mouseout, mouseover, mouseup, move, out, over, touchdown, touchdrag, touchup, up

Class Detail
JXG.Line(board, p1, p2, id, name, withLabel, layer)
The Line class is a basic class for all kind of line objects, e.g. line, arrow, and axis. It is usually defined by two points and can be intersected with some other geometry elements.

Parameters:
{String|JXG.Board} board
  The board the new line is drawn on.
{Point} p1
  Startpoint of the line.
{Point} p2
  Endpoint of the line.
{String} id
  Unique identifier for this object. If null or an empty string is given, an unique id will be generated by Board
{String} name
  Not necessarily unique name. If null or an empty string is given, an unique name will be generated.
{Boolean} withLabel
  construct label, yes/no
{Number} layer
  display layer [0-9]

See:
  JXG.Board#generateName

Field Detail
{JXG.Ticks} defaultTicks
Reference of the ticks created automatically when constructing an axis.

See:
  JXG.Ticks

<private> {JXG.Polygon} parentPolygon
If the line is the border of a polygon, the polygon object is stored, otherwise null.

Default Value:
  null

{JXG.Point} point1
Startpoint of the line. You really should not set this field directly as it may break JSXGraph's update system so your construction won't be updated properly.

{JXG.Point} point2
Endpoint of the line. Just like JXG.Line.point1 you shouldn't write this field directly.

{Array} ticks
Array of ticks storing all the ticks on this line. Do not set this field directly and use JXG.Line#addTicks and JXG.Line#removeTicks to add and remove ticks to and from the line.

See:
  JXG.Ticks

Method Detail
{String} addTicks(ticks)
Adds ticks to this line. Ticks can be added to any kind of line: line, arrow, and axis.

Parameters:
{JXG.Ticks} ticks
  Reference to a ticks object which is describing the ticks (color, distance, how many, etc.).

Returns:
  {String} Id of the ticks object.

{JXG.Line} addTransform(transform)
Add transformations to this line.

Parameters:
{JXG.Transformation|Array} transform
  Either one JXG.Transformation or an array of JXG.Transformations.

Returns:
  {JXG.Line} Reference to this line object.

<private> {Array} generatePolynomial(p)
Used to generate a polynomial for a point p that lies on this line, i.e. p is collinear to JXG.Line#point1 and JXG.Line#point2.

Parameters:
{JXG.Point} p
  The point for that the polynomial is generated.

Returns:
  {Array} An array containing the generated polynomial.

{Number} getAngle()
Determines the angle between the positive x axis and the line.

Returns:
  {Number}

{Number} getRise()
Calculates the y intersect of the line.

Returns:
  {Number} The y intersect.

{Number} getSlope()
Calculates the slope of the line.

Returns:
  {Number} The slope of the line or Infinity if the line is parallel to the y-axis.

{Boolean} hasPoint(x, y)
Checks whether (x,y) is near the line.

Parameters:
{Number} x
  Coordinate in x direction, screen coordinates.
{Number} y
  Coordinate in y direction, screen coordinates.

Returns:
  {Boolean} True if (x,y) is near the line, False otherwise.

{Number} L()
The distance between the two points defining the line.

Returns:
  {Number}

<private> maxX()
Treat the element as parametric curve

<private> minX()
Treat the element as a parametric curve

removeAllTicks()
Removes all ticks from a line.

removeTicks(tick)
Removes ticks identified by parameter named tick from this line.

Parameters:
{JXG.Ticks} tick
  Reference to tick object to remove.

<private> setLabelRelativeCoords(relCoords)
Adjusts Label coords relative to Anchor. DESCRIPTION

Parameters:
relCoords

<private> setStraight(straightFirst, straightLast)
Determines whether the line is drawn beyond JXG.Line#point1 and JXG.Line#point2 and updates the line.

Parameters:
{Boolean} straightFirst
  True if the Line shall be drawn beyond JXG.Line#point1, false otherwise.
{Boolean} straightLast
  True if the Line shall be drawn beyond JXG.Line#point2, false otherwise.

See:
  #straightFirst
  #straightLast

<private> updateRenderer()
Uses the boards renderer to update the line.

<private> updateSegmentFixedLength()
Update segments with fixed length and at least one movable point.

<private> updateStdform()
Updates the stdform derived from the parent point positions.

{Number} X(t)
Treat the line as parametric curve in homogeneous coordinates, where the parameter t runs from 0 to 1. First we transform the interval [0,1] to [-1,1]. If the line has homogeneous coordinates [c,a,b] = stdform[] then the direction of the line is [b,-a]. Now, we take one finite point that defines the line, i.e. we take either point1 or point2 (in case the line is not the ideal line). Let the coordinates of that point be [z, x, y]. Then, the curve runs linearly from [0, b, -a] (t=-1) to [z, x, y] (t=0) and [z, x, y] (t=0) to [0, -b, a] (t=1)

Parameters:
{Number} t
  Parameter running from 0 to 1.

Returns:
  {Number} X(t) x-coordinate of the line treated as parametric curve.

{Number} Y(t)
Treat the line as parametric curve in homogeneous coordinates. See JXG.Line#X for a detailed description.

Parameters:
{Number} t
  Parameter running from 0 to 1.

Returns:
  {Number} Y(t) y-coordinate of the line treated as parametric curve.

{Number} Z(t)
Treat the line as parametric curve in homogeneous coordinates. See JXG.Line#X for a detailed description.

Parameters:
{Number} t
  Parameter running from 0 to 1.

Returns:
  {Number} Z(t) z-coordinate of the line treated as parametric curve.